.\" The Debian PCMCIA-CS README File
.\"  roff source
.ie n \{ \"    If nroff'ed
.nr LL 75m \"      Width = 75 chars
.na \"             No justification
.nr HY 0 \"        No hyphenation
\}
.el \{ \"      Else
.nr LL 6.5i \"     Line length 6 1/2"
\}
.de Vv \"      Verbatim word
'ie t \{\f(CW\\$1\fP\\$2\}
'el \{\\$1\\$2\}
..
.de Vs \"      Start verbatim environment
.RS \"             Indent block
'nf \"             No fill
'if t \{
'ft CW \"          Courier constant width font
\}
..
.de Ve \"      End verbatim environment
'if t \{
'R \"              Roman font
\}
'fi \"             Fill
.RE \"             End indent
..
.ds PC \s-2PCMCIA\s+2\" PCMCIA in small type
.TL \" Title
Debian \*(PC Card Services
.br \" newline
README File
.AU \" Author
Brian Mays <brian@debian.org>
.LP \" Paragraph
This is the Debian GNU/Linux prepackaged version of the \*(PC card
services package.
.LP
By default,
.I debian/rules
will set the kernel-specific options from the kernel source tree in
.I /usr/src/linux \c
\&.  If this is not desirable, execute `\c
.Vv "make config" '
in the
.I pcmcia-cs
root directory to interactively configure the package.
.LP
You need to have a complete linux source tree for your kernel, not
just an up-to-date kernel image, to compile the \*(PC package.  The
\*(PC modules contain some references to kernel source files.  While
you may want to build a new kernel to remove unnecessary drivers,
installing \*(PC does not require you to do so.
.SH \"		Section
To recompile the \*(PC kernel modules:
.RS \"		Indent one level
.LP
The process of recompiling a kernel and the \*(PC modules has been
greatly simplified by Debian's
.I kernel-package
package (available in Debian's main distribution).  This package
contains the
.I make-kpkg
utility, which is used to create the kernel related Debian packages.
It is highly recommended that you use this utility.
.SH
If you are using \fImake-kpkg\fP:
.IP 1)                  \" Hanging indent
Ensure that the
.I pcmcia-cs
source tree is in a subdirectory of the
.I /usr/src/modules
directory.  Use a symbolic link to the actual source tree if you must.
Note that the
.I pcmcia-source
package already places the
.I pcmcia-cs
sources in
.I /usr/src/modules/pcmcia-cs \c
\&.
.IP 2)
As root, go to the the base of the kernel source tree (usually the
.I /usr/src/linux
directory).  If you are building a kernel that is custom configured to
your specifications, go ahead and configure the kernel with `\c
.Vv "make config" ,'
`\c
.Vv "make menuconfig" ,'
or `\c
.Vv "make xconfig" .'
.IP 3)
To build a new
.I kernel-image
package, execute:
.Vs \"		Verbatim
make-kpkg \-\-revision \fInumber\fP kernel_image
.Ve \"		Verbatim end
This will generate a
.I "kernel-image-<kernel version>"
deb file in the parent directory.  Here
.I number
(the argument supplied after the
.B \-\-revision
flag) is a version number for your custom built kernel.  You may also
do this on the fly by setting the
.B DEBIAN_REVISION
environmental variable.  It is important that you choose the revision
number in such a way that a generic
.I kernel-image
package will not override the custom package while using
.I dselect
(or `\c
.Vv "dpkg \-BOGiE" ').
I recommend a two-level scheme where the major level starts with a letter.
One such scheme is your (short) host name followed by a dot (.) and
a number.  For example, if your machine is named
.I myhost \c
\&, you would use
.B \-\-revision
myhost.1 in the command line.  If you had to rebuild your custom kernel,
you would use
.B \-\-revision
myhost.2 and so on.  See
.I /usr/doc/kernel-package/README.gz
for more information on revision numbers.
.IP 3)
To build the \*(PC modules, execute:
.Vs
make-kpkg \-\-revision \fInumber\fP modules_image
.Ve
where
.I number
is the same revision number used to build the
.I kernel-image
package in the previous step. This will generate a
.I "pcmcia-modules-<kernel version>"
deb file in the parent directory.
.IP 4)
Install the two newly created deb files (you can use `\c
.Vv "dpkg \-i " \c
.I file \c
\&').
.SH
If you are not using \fImake-kpkg\fP:
.LP
If your kernel is compiled with
.B CONFIG_MODVERSIONS
enabled, for kernel symbol version checking, the configure script will
check for the existence of
.I /usr/include/linux/modversions.h \c
\&, the symbol version database.  This is created by running `\c
.Vv "make dep" '
(in addition to `\c
.Vv "make config" )
in the kernel source tree.
.IP 1)
Ensure that the kernel source tree is in the
.I /usr/src/linux
directory and ensure that it is configured (execute `\c
.Vv "make config dep" '
in the
.I /usr/src/linux
directory).
.IP 2)
Go to the
.I pcmcia-cs
root directory (\c
.I /usr/src/modules/pcmcia-cs
in the
.I pcmcia-source
package).
.IP 3)
Execute as root `\c
.Vv "debian/rules binary-modules" .'
This will generate a
.I "pcmcia-modules-<kernel version>"
deb file in the parent directory.
.LP
.B Note: 
The location of the kernel source tree may be specified by supplying
the
.B KSRC
variable as a command line option.  For example, if the kernel source
is located in
.I /usr/local/src/kernel-2.0.0 \c
\&, the proper command would be
.Vs
debian/rules KSRC=/usr/local/src/kernel-2.0.0 binary-modules
.Ve
.RE
.SH
To recompile the \*(PC utility programs:
.RS
.LP
This should not be necessary, since the generic
.I pcmcia-cs
package supplied by Debian should be compatible with all
.I "pcmcia-modules-<kernel version>"
packages (including custom built packages) with the same version number.
However, if you need to build a complete set of \*(PC modules and
utilities\(emto use a newer upstream version, for example\(emyou can
use the following procedure:
.IP 1)
Ensure that the kernel source tree is in the
.I /usr/src/linux
directory and ensure that it is configured (execute `\c
.Vv "make config dep" '
in the
.I /usr/src/linux
directory).
.IP 2)
Go to the
.I pcmcia-cs
root directory (\c
.I /usr/src/modules/pcmcia-cs
in the
.I pcmcia-source
package).
.IP 3)
Execute as root `\c
.Vv "debian/rules binary-cs" .'
This will generate the
.I pcmcia-cs
deb file.
.LP
.B Note: 
The location of the kernel source tree may be specified by supplying the
.B KSRC
variable as a command line option.  For example, if the kernel source is located in
.I /usr/local/src/kernel-2.0.0 \c
\&, the proper command would be
.Vs
debian/rules KSRC=/usr/local/src/kernel-2.0.0 binary-cs
.Ve
.RE
