#!/bin/sh
# genchanges.sh - generate a changes file for a deb file generated via
#	the make-kpkg utility

# KSRC and KMAINT are expected to be passed through the environment

set -e

KVERS=`cat debian/KVERS`
MODVERS=`cat debian/MODVERS`
ARCH=`dpkg --print-architecture`

# the changes file's name
chfile="$KSRC/../pcmcia-modules-${KVERS}_${MODVERS}_${ARCH}.changes"

dpkg-genchanges -b ${KMAINT:+-m"$KMAINT"} -u"$KSRC/.." \
	-cdebian/control.tmp -fdebian/files-modules > "$chfile.pt"
pgp -fast ${kmaint:+-u"$kmaint"} < "$chfile.pt" > "$chfile"
rm "$chfile.pt"
